#ifndef __AQSIS_FILE_H
#define __AQSIS_FILE_H

#include "aqsis_Render.h"

class aqsisFileRender_t : public aqsisRender_t
{
	public:
		virtual ~aqsisFileRender_t() {}
                static std::string getMaterialRIBName(const Material* mat,
                        const string &ribpath, bool relative);
                static std::string getMaterialDobbyName(const Material* mat,
                        const string &ribpath, bool relative);
	protected:
		std::string imgout;
		std::string ribfile;
		std::string ribpath;

		bool executeAqsis(const std::string &ribpath);
		virtual bool initExport();
		virtual bool finishExport();
		virtual void writeFrame();
		virtual void writeCamera();
		virtual void writeAllObjects(int shadowpass);
		virtual void writeMaterialsAndModulators();
		virtual void writeLamps();
		virtual void switchLayerLamps(int layer);
		virtual void writeShadowMap(LampRen* lamp);
		virtual std::string getShadowName(LampRen* lamp, 
                        bool relative);
                virtual void writeMaterial(Material* mat);
};

#endif
