/**
 * BL_light.sl
 */

#include "light_functions.h"

light
BL_light (
	string lighttype            = "lamp";
	uniform float energy        = 1.0;
	uniform color colour        = 1.0;
	uniform float dist          = 30.0;
	uniform float negative      = 0;	/* boolean */
	uniform float quad          = 0;	/* boolean */
	uniform float sphere        = 0;	/* boolean */
	uniform float quad1         = 0.0;
	uniform float quad2         = 0.0;
	varying float __nonspecular = 0;	/* boolean */
	varying float __nondiffuse  = 0;	/* boolean */
	float __foglight            = 0;	/* ? */
	/* shadow and spot section */
	uniform float spotSi        = 0.5;	/* dot product */
	uniform float spotBl        = 0.0;	/* dot product */
	uniform float haloInt       = 1.0;
	uniform float square        = 0;	/* boolean */
	uniform float samples       = 3;	/* int */
	uniform float soft          = 3.0;
	uniform float bias          = 1.0;
	uniform string shadowmap    = "";
	uniform float onlyshadow    = 0;	/* boolean */
	/* texture section */
	uniform string texmaptype[8]     = { "","","","","","","","" };
	uniform string texblendtype[8]   = { "","","","","","","","" };
	uniform float  texColValue[8]    = { 0,0,0,0,0,0,0,0 };
	uniform color  texcolor[8]       = { 0,0,0,0,0,0,0,0 };
	uniform color  texfiltercolor[8] = { 0,0,0,0,0,0,0,0 };
	uniform float  texcontrast[8]    = { 0,0,0,0,0,0,0,0 };
	uniform float  texbrightness[8]  = { 0,0,0,0,0,0,0,0 };
	uniform float  texnoisedepth[8]  = { 0,0,0,0,0,0,0,0 };
	uniform float  texnoisesize[8]   = { 0,0,0,0,0,0,0,0 };
	uniform float  texnoiseturb[8]   = { 0,0,0,0,0,0,0,0 };
	uniform float  texnoisetype[8]   = { 0,0,0,0,0,0,0,0 };
	uniform float  texnoiseStype[8]  = { 0,0,0,0,0,0,0,0 };
	uniform vector texofs[8]         = { 0,0,0,0,0,0,0,0 };
	uniform vector texsize[8]        = { 0,0,0,0,0,0,0,0 };
) {
	point from = point "shader" (0,0,0);

	/* switch between the various lamp types */
	if ("lamp" == lighttype) {
		lamp(from, colour, dist, quad, sphere, quad1, quad2);
	} else if ("spot" == lighttype) {
		spot(from, colour, energy, dist, quad, sphere, quad1, quad2,
			spotSi, spotBl, square, 
			shadowmap, samples, soft, bias, onlyshadow);
	} else if ("sun" == lighttype) {
		sun(colour);
	} else if ("area" == lighttype) {
		/* as yet unsupported */
	} else if ("hemi" == lighttype) {
		hemi(colour);
	}

}
