/**
 * Shows depth into the scene as a linear function, such that the start of
 * world mist is black and the end is white.
 */
surface BL_shadebug_showmist(
        uniform float sta = 0;  /* start of mist */
        uniform float di  = 10; /* distance of mist */
)
{
        point Pworld = transform("world", P);
        point Eworld = transform("world", E);

        float d = length(Pworld - Eworld);
        float base_color = (d - sta) / di;
        Ci = base_color;
        Oi = 1;
}
