/**
 * Special debugging shader to show the normals on objects.
 *
 * Normals pointing toward the camera are shaded green, those pointing away
 * from the camera are shaded red.
 */
surface BL_shadebug_shownormals () 
{
        color normals_base_color;
        if (N.I < 0)
                normals_base_color = color(0,1,0);
        else
                normals_base_color = color(1,0,0);

        float shadot = abs(normalize(N).normalize(I));
        Ci = ((0.8 * shadot) + 0.2) * normals_base_color;
        Oi = 1.0;
}
