/**
 * util.h
 */
#ifndef DOBBY_UTIL_H
#define DOBBY_UTIL_H

/**
 * A small floating-point value.
 */
#define EPSILON (1.0e-5)

/**
 * Copies the first three elements from one array to another.
 *
 * \param dest  Destination.
 * \param src   Source.
 */
#define CP_TRIPLE(dest, src) \
{ \
        dest[0] = src[0]; \
        dest[1] = src[1]; \
        dest[2] = src[2]; \
}

/**
 * Converts a color to a float using Blender's formula for energy:
 *    0.3  red
 *    0.58 green
 *    0.12 blue
 */
#define COLOR_TO_FLOAT(c) \
        ( 0.3*(c)[0] + 0.58*(c)[1] + 0.12*(c)[2] )

#endif // DOBBY_UTIL_H
