/**
 * $Id: Tangent.vs 839 2004-09-11 23:57:19Z kester $
 * ***** BEGIN GPL/BL DUAL LICENSE BLOCK *****
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. The Blender
 * Foundation also sells licenses for use in proprietary software under
 * the Blender License.  See http://www.blender.org/BL/ for information
 * about this.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The Original Code is Copyright (C) 2001-2002 by NaN Holding BV.
 * All rights reserved.
 *
 * The Original Code is: all of this file.
 *
 * Contributor(s): none yet.
 *
 * ***** END GPL/BL DUAL LICENSE BLOCK *****
 *
 * Tangent Space utilites.
 *
 * TARGET: Vertex Processor
 */

vec3 BL_BiTangent(const vec4 tangent)
{
	return cross(tangent.xyz, gl_Normal.xyz)*tangent.w;
}

mat3 BL_TangentSpace(const vec4 tangent)
{
	return mat3(tangent.xyz,
		    BL_BiTangent(tangent),
		    gl_Normal);
}

vec3 BL_TangentTransform(const vec3 vector, const vec4 tangent, const vec3 origin)
{
	return vec3(dot(tangent.xyz, vector),
		    dot(BL_BiTangent(tangent), vector),
		    dot(gl_Normal, vector)) - origin;
}
