/**
* $Id: OdeMesh.h 133 2003-10-05 02:56:47Z kester $
*
 * ***** BEGIN GPL/BL DUAL LICENSE BLOCK *****
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. The Blender
 * Foundation also sells licenses for use in proprietary software under
 * the Blender License.  See http://www.blender.org/BL/ for information
 * about this.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The Original Code is Copyright (C) 2001-2002 by NaN Holding BV.
 * All rights reserved.
 *
 * The Original Code is: all of this file.
 *
 * Contributor(s): none yet.
 *
 * ***** END GPL/BL DUAL LICENSE BLOCK *****
*/
#ifndef ODE_MESH_H
#define ODE_MESH_H

#include <vector>

#include <ode/ode.h>

#include "MT_Point3.h"
#include "RAS_MeshObject.h"
#include "OdeSensor.h"

class RAS_MeshObject;

class ODEMesh : public ODESensor
{
	struct vertex {
		dVector3 pt;
	};
	dSpaceID	m_world;
	dTriMeshDataID	m_tris;
	std::vector<struct vertex>	vertexarray;
	std::vector<RAS_TriangleIndex>	indexarray;

	dVector3	m_scaling;
public:
	ODEMesh(dSpaceID space, ODEPhysicsController *ctrl, KX_ICollisionSensor *sens );
	~ODEMesh();

	void Trimesh(RAS_MeshObject *mesh);

	virtual void setScaling(dVector3 s);
	virtual void setSpace(dSpaceID s);

	virtual void HandleCollision(ODESensor *obj2);

};

#endif

