#ifndef _BKE_DFDFORM_H
#define _BKE_DFDFORM_H

#include "DNA_listBase.h"

struct Material;
struct ListBase;
struct HE_EditMesh;
struct HE_Mesh;
struct DF_Deform;
struct DF_DeformList;

typedef struct DF_Deform {
    struct DF_Deform *next, *prev;
    float *vert_list;
    float *no_list;
    int type;
} DF_Deform;
    
typedef struct DF_DeformList {
    ListBase deforms;
    DF_Deform *base;
    void (*applyDef)(DF_Deform *def, void *data);
    void (*loadBase)(DF_Deform *def, void *data);
    int totvert;
    void *data;
} DF_DeformList;

#define DF_LATTICE	1
#define DF_ARMATURE	2
#define DF_HOOK		3

/* deform stuff. . . */
extern void HE_apply_def(DF_Deform *def, void *data);
extern void DF_deformlist_free(struct DF_DeformList *deflist);
extern struct DF_Deform *HE_make_deform(HE_Mesh *me);
extern void DF_deform_free(struct DF_Deform *def);
extern DF_Deform *DF_NewDeform(int totvert);
extern void DF_SetModifiers(DF_DeformList *def, Object *ob);
extern void DF_ApplyModifiers(DF_DeformList *defl, Object *ob);
extern void HE_load_base(DF_Deform *base, void *data);

#endif /* _BKE_DFDFORM_H */
