#ifndef _BKE_DMESH_H
#define _BKE_DMESH_H
#include "DNA_listBase.h"

struct Material;
struct ListBase;
struct Mesh;
struct HE_EditMesh;
struct HE_Mesh;
struct DF_Deform;
struct DF_DeformList;

/*a 99% indice-based intermidatory display structure*/
typedef struct DVertIndiceArray
{
	int *array;
	int len;
	int cursor;
} DVertIndiceArray;
#define DVERT_INCR  4096

/*this next one uses .array, too*/
typedef struct DCol
{
	float col[3];
	int vert;
} DCol;

typedef struct DVert
{
	float co[3];
	float no[3];
	float shade_no[3];
	float vcol[3];
	int f;
	int f1;
	void *ref;
	int hook;
} DVert;

typedef struct DEdge
{
	int v1, v2;
	int f;
	char seam;
	float crease;
	void *ref;
} DEdge;

/** unlike HE mesh faces, DFace uses normal
	MFace mesh flags */
typedef struct DFace
{
	int verts;
	int cols;
	int vlen;
	float no[3];
	int f, mat, edcode;
	void *ref;
} DFace;

typedef struct DMesh
{
	DVert *verts;
	DEdge *edges;
	DFace *faces;
	DCol *cols;
	int totface, totedge, totvert;
	int totcol, f;
	struct Material **mat;
/*a face's lists of verts is stored in .array, kindof
 like a memarena, but not really.*/
	DVertIndiceArray *array;
	struct DeformList *deform;
	struct DerivedMesh *deriv;
	int gdl_solid;
	int gdl_wire;
} DMesh;

DMesh *subSurf_make_DMesh_fromHEMesh(HE_Mesh *me, int subdivLevels);
void free_DMesh(DMesh *dm);
DMesh *make_DMesh_from_HEMesh(HE_Mesh *mesh);
void draw_DMesh(DMesh *dm, int dt);
void dmesh_calcFaceNormals(DMesh *dm);
void dface_AddVerts(DMesh *dm, DFace *df, int *verts, int vlen);
struct DerivedMesh *HE_subsurf_ccg_make_derived_from_editmesh(struct HE_EditMesh *em, int subdivLevels);
struct Mesh *DMesh_to_Mesh(struct DMesh *oldme, int do_libblock,
float **face_nors);
void dmesh_calc_vertnormals(DMesh *dm);

/*opengl display lists functions, should be in displist.c
  put are with dmesh to prevent merging woes*/
int GDL_NewDispList(void);
void GDL_DeleteDispList(int dlid);
void GDL_CallList(int list);
int GDL_EndDispList(void);
#endif											  /* _BKE_DMESH_H */
