#ifndef _HE_EDITMESH_H
#define _HE_EDITMESH_H

/*these are for he_unified_findnearest*/ 
#define HEVERT	1
#define HEEDGE	2
#define HEIEDGE	3
#define HEFACE	4
#define HENONE	5

struct i_arraypointer;
struct HE_EditMesh;
struct HE_EditFace;
struct HE_EditEdge;
struct HE_EditEdgeInfo;
struct HE_EditVert;
struct heUndoMesh;
struct ListBase;

struct HE_EditEdge **he_getSolidsAroundVert(struct HE_EditMesh *em, struct HE_EditVert *eve);
void he_free_HEEditMesh(struct HE_EditMesh *em);
struct HE_EditEdgeInfo *find_iedge(struct HE_EditMesh *em, struct HE_EditVert *v1, struct HE_EditVert *v2);
int HE_getHoles(void);
void HE_delete_halfedge(struct HE_EditMesh *em, struct HE_EditEdge *eed);
void he_set_blockmem(struct HE_EditMesh *em, int type, int tot);
void he_load_HEEditMesh(struct HE_Mesh *me, struct HE_EditMesh *em);
struct HE_EditFace **HE_GetFaceLoop(struct HE_EditEdgeInfo *ieed);
struct HE_EditEdgeInfo **HE_GetEdgeLoop(struct HE_EditEdgeInfo *ieed);
int he_unified_findnearest(struct HE_EditMesh *em, void **ptr, int pdis);
void *heeditmeshToUndoMesh(void);
void freeundoHE(struct heUndoMesh *undo);
struct HE_EditMesh *undomeshToHEEditMesh(struct heUndoMesh *undo);
void undo_push_hemesh(char *str);
void check_faces(struct HE_EditMesh *em);
/*thse next two functions, if used at all, can only be called from
  euler operator functions!!!!*/
void HE_ManualEdgeAdd(struct HE_EditMesh *em, struct HE_EditEdge *eed);
struct HE_EditEdge *HE_addedgelist_nosearch(struct HE_EditMesh *em, struct HE_EditVert *v1, struct HE_EditVert *v2);
void HE_select_iedge(struct HE_EditEdgeInfo *ieed);
void HE_deselect_iedge(struct HE_EditEdgeInfo *ieed);
/** must NEVER be called from UI! this is not tool-API-afied!
  meant as an internal function for tools!!*/
void he_deselect_all(void);

void HE_add_missing_ieeds(void);

/*************Event stuff****************/
void HET_EditModeEvent(unsigned short evt, int val);
void clear_all_mover(void);
void he_mouseover(void);
void hemesh_evt(unsigned int evt, short val);
void mouse_hemesh_loop(void);
void mouse_hemesh_select(void);
void mouse_hemesh(void);
void HET_Event(unsigned short evt, int val);
void he_selectface_border_f(short min[2], short max[2], int selmode);
unsigned int *he_sample_polyshape(short shape[][2], int len, int sizex, int sizey);

/************ Drawing stuff *********/
void he_draw_bbsedges(void *data);
void he_draw_bbsverts(void *data);
void he_draw_bbsfaces(void *data);

/*********** Mesh conversion stuff***/
void free_HEEditMesh(void);
void load_HEEditMesh(void);
void make_HEEditMesh(void);

/************functions that need to be TOOL-AFIED!**********/
void HE_recalc_facenormals(void);
void HET_Duplicate(void);

/********************** geometry stuff ********************/
/***verts***/
struct HE_EditVert *HE_addvertlist3f(float x, float y, float z);
struct HE_EditVert *HE_addvertlist(struct HE_EditMesh *em, float *co);
void HE_delete_vert(struct HE_EditMesh *em, struct HE_EditVert *eve);


/***edges***/
struct HE_EditEdge *HE_addedgelist(struct HE_EditMesh *em, struct HE_EditVert *v1, struct HE_EditVert *v2);
void HE_delete_edge(struct HE_EditMesh *em, struct HE_EditEdge *eed);
void he_delete_iedge(struct HE_EditMesh *em, struct HE_EditEdgeInfo *ieed);
void collapse_edge(struct HE_EditMesh *em, struct HE_EditEdge *eed);

/***faces***/	
struct HE_EditFace *HE_addfacelist(struct HE_EditMesh *em, struct HE_EditVert **vert_list, int len);
void HE_delete_face(struct HE_EditMesh *em, struct HE_EditFace *efa);

/******************* Selection Stuff *********************/
void deselectall_hemesh(void);
void HE_faceselect_flush(void);
void HE_edgeselect_flush(void);
void HE_update_edges(struct HE_EditMesh *em);
void HE_update_faces(struct HE_EditMesh *em);
void HE_select_iedge(struct HE_EditEdgeInfo *ieed);
void HE_deselect_iedge(struct HE_EditEdgeInfo *ieed);
void HE_select_face(struct HE_EditFace *efa);
void HE_deselect_face(struct HE_EditFace *efa);
struct HE_EditVert *HE_findnearestvert_f(struct HE_EditMesh *em, short max_dis); 
struct HE_EditVert *HE_findnearestvert(struct HE_EditMesh *em, short dis); 
float he_dist_mval_edge(short *mval, struct HE_EditEdge *eed);
struct HE_EditEdgeInfo *HE_findnearestedge_f(struct HE_EditMesh *em, short max_dis);
struct HE_EditEdgeInfo *HE_findnearestedge(struct HE_EditMesh *em, short dis); 
struct HE_EditFace *HE_findnearestface_f(struct HE_EditMesh *em, short max_dis); 
struct HE_EditFace *HE_findnearestface(struct HE_EditMesh *em, short dis);
void HE_clear_flag_faces(struct HE_EditMesh *em, int f);
void HE_clear_flag_edges(struct HE_EditMesh *em, int f);
void HE_clear_flag_verts(struct HE_EditMesh *em, int f);
void mouse_hemesh();
void HE_recalcnormals(void);
/** Pops a vert from a face.  
 * @return Whether or not the face had to be deleted,
 * as 0/1
 */
int HE_pop_vert_from_face (struct HE_EditFace *efa, struct HE_EditVert *eve);
struct HE_EditEdge **he_getHEdgesAroundVert(struct HE_EditMesh *em, struct HE_EditVert *eve);
struct HE_EditFace **he_getFacesAroundVert(struct HE_EditMesh *em, struct HE_EditVert *eve);
struct HE_EditVert **he_getVertsAroundVert(struct HE_EditMesh *em, struct HE_EditVert *eve);

/********** Mesh Sdding Stuff *******/
void *add_hemesh(void);
void addPrimitiveHEMesh(int type);
struct HE_EditVert *split_edge(struct HE_EditMesh *em, struct HE_EditEdge *eed);
struct HE_EditFace *HE_pop_face(struct HE_EditFace *efa, struct HE_EditVert *eve, struct HE_EditMesh *em);

/********** Mesh drawing stuff*******/

/**********Macro stuff***********/
void HE_push_stack(struct ListBase *stack, struct HE_EditTool *tool, char *arg_string);
void HE_free_toolstack(struct ListBase *stack);

/************Drawing stuff**********/
/*mode: 1 = backbuffered faces, 2 = black, 0 = optimal edges*/
void HED_drawSubSurfFaces(char mode);
void HED_drawSubSurfEdges(char mode, char alpha);
void drawHEEMeshSolid(char mode);

void drawMEWire(struct HE_Mesh *me);
void drawMESolid(struct HE_Mesh *me);
void drawHEMesh(struct Object *ob, unsigned int dt);
void calc_hemesh_vertdots_ext(void);
void calc_hemesh_facedots_ext(void);
void he_draw_edges(unsigned char alpha);
void he_draw_verts(char alpha);
void he_draw_facedots(unsigned char alpha);
void HEE_drawHEEditMesh(unsigned int dt);
int HE_getComponents(void);
void HE_remake_pairs(void);
struct HE_EditVert **HE_GetLinkedVerts(struct HE_EditVert *seve, float limit, int skip_clearflags, int max_depth);
void HE_clear_flag_all(int flag);
void switch_face(struct HE_EditFace *efa);

/*********** Undo ****************/
typedef struct heUndoHashEdge {
	struct heUndoHashEdge *next, *prev;
	struct heUndoHalfEdge *eed;
	int index;
} heUndoHashEdge;	

typedef struct heUndoVert {
	struct HE_EditVert *neve;
	
	unsigned int f, f1, h;
	float co[3];
	float ssco[3];
	float no[3];
	struct heUndoHalfEdge *edge;
	int index;
	ListBase hash;
	//struct heUndoHashEdge *hashfirst, *hashlast; /*this is a linked-list*/
} heUndoVert;

struct heUndoFace;
struct heUndoHalfEdge;
struct heUndoEdgeInfo;
struct heUndoMesh;

typedef struct heUndoEdgeInfo {
	struct HE_EditEdgeInfo *nieed;
	
	struct heUndoHalfEdge *e1, *e2;
	unsigned int f, f1, h;
	float crease;
	char seam;
	int index;
} heUndoEdgeInfo;

typedef struct heUndoHalfEdge {
	struct HE_EditEdge *need;
	
	struct heUndoVert *v1, *v2;
	struct heUndoHalfEdge *enext, *eprev;
	struct heUndoHalfEdge *pair;
	struct heUndoEdgeInfo *ieed;
	struct heUndoFace *face;
	unsigned int f1;
	int index;
	float no[3];
} heUndoHalfEdge;

typedef struct heUndoFace {
	struct HE_EditFace *nefa;
	
	unsigned int f, f1, h, mat;
	struct heUndoHalfEdge *edge;
	float cent[3];
	float no[3];
	int index;
} heUndoFace;

typedef struct heUndoMesh {
	struct heUndoFace *faces;
	int totf;
	struct heUndoHalfEdge *half_edges;
	int tothe;
	struct heUndoEdgeInfo *iedges;
	int totie;
	struct heUndoVert *verts;
	int totv;
	struct heUndoHashEdge *hashes;
	int tothash;
	int index;
} heUndoMesh;


#endif /* _HE_EDITMESH_H */
