#ifndef _HE_ERROR_H
#define _HE_ERROR_H

#include "DNA_listBase.h" 

enum {
	HE_UNDEFINED_ERROR = 1,
	HE_CANCELED,
	HE_BAD_ARGUMENT_STRING,
	HE_NON_MANIFOLD,
	HE_NO_MESHDATA,
	HE_NOTOOL,
	HE_BADINDEX,
	HE_INVALID_SELECTION,
	HE_SEL_MUST_BE_SAME,
	HE_CUSTOM_STRING,
};

typedef struct he_toolerror_entry {
	struct Link link;
	/*these two will remain commented out for now
	  todo later when we get to scripting and more controllable
	  tool parameters.
	  HE_EditTool *tool;
	  char *arg_string;*/
	char errorcode;
} he_toolerror_entry;

int HE_CheckError(void);
int HE_CatchError(int errorcode);
void HE_PrintErrorStack(void);
void HE_RaiseError(int errorcode); 
void HE_RaiseErrorString(char *str);
char *HE_ErrorCodeToString(int code);

#endif /* _HE_ERROR_H */

