#ifndef _HE_TOOLS_H
#define _HE_TOOLS_H

struct ScrArea;

extern struct ScrArea *curarea;

typedef struct HE_DiffVert
{
	int index;
	int type;
	float co[2];
	float no[2];
	int edge;
	unsigned int f;
} HE_DiffVert;

typedef struct HE_DiffHEdge
{
	int v1;
	int next;
	int prev;
	int pair;
	int face;
} HE_DiffEdge;

typedef struct HE_DiffIEdge
{
	int e1;
	int e2;
	unsigned int f;
} HE_DiffIEdge;

typedef struct HE_DiffIFace
{
	int hedge;
	unsigned int f;
} HE_DiffIFace;

typedef struct HE_DiffMesh
{
	struct HE_DiffVert *verts;
	int totverts;
	struct HE_DiffHEdge *hedges;
	int tothedges;
} HE_DiffMesh;

struct HE_EditMesh;
struct ListBase;

char *HE_DelVertTool(char *arg_string, struct HE_EditMesh *em);
char *HE_SubdivideTool(char *arg_string, struct HE_EditMesh *em);
char *HE_SubdivSmoothTool(char *arg_string,struct  HE_EditMesh *em);
char *HE_SelectMoreTool(char *arg_string, struct HE_EditMesh *em);
char *HE_SelectLessTool(char *arg_string, struct HE_EditMesh *em);
char *HE_ExtrudeRegionTool(char *arg_string, struct HE_EditMesh *em);
char *HE_MoveNormalTool(char *arg_string, struct HE_EditMesh *em);
char *HE_MoveTool(char *arg_string, struct HE_EditMesh *em);
char *HE_ExtendEdgesTool(char *arg_string, struct HE_EditMesh *em);
char *HE_DelFaceTool(char *arg_string, struct HE_EditMesh *em);
char *HE_DelEdgeTool(char *arg_string, struct HE_EditMesh *em);
char *HE_MergeTool(char *arg_string,struct  HE_EditMesh *em);
char *HE_SmoothShadeTool(char *arg_string, struct HE_EditMesh *em);

char *HET_FindAndSelectVert(int dis);
char *HE_SelVertTool(char *arg_string,struct  HE_EditMesh *em);

void HET_FindAndSelectEdge(void);
char *HE_SelEdgeTool(char *arg_string, struct HE_EditMesh *em);

void HET_FindAndSelectFace(void);
char *HE_SelFaceTool(char *arg_string, struct HE_EditMesh *em);
char *HE_SelSwapTool(char *arg_string, struct HE_EditMesh *em);
char *HE_HideSelTool(char *arg_string, struct HE_EditMesh *em);
char *HE_RevealSelTool(char *arg_string,struct  HE_EditMesh *em);

char *HE_SolidShadeTool(char *arg_string, struct HE_EditMesh *em);
char *HE_JoinFacesTool(char *arg_string,struct  HE_EditMesh *em);
char *HE_TriangulateTool(char *arg_string, struct HE_EditMesh *em);
char *HE_ExtrudeVertTool(char *arg_string, struct HE_EditMesh *em);
char *HE_EdgeCreaseTool(char *arg_string, struct HE_EditMesh *em);
char *HE_SelLinkedTool(char *arg_string, struct HE_EditMesh *em);
char *HE_ExtrudeFaceTool(char *arg_string, struct HE_EditMesh *em);
char *HE_AverageTool(char *arg_string, struct HE_EditMesh *em);
char *HE_FlipAllNormalsTool(char *arg_string,struct  HE_EditMesh *em);
char *HE_AssignMatTool(char *arg_string,struct  HE_EditMesh *em);
char *HE_SelectMatTool(char *arg_string, struct HE_EditMesh *em);

char *HE_HardEdgeTool(char *arg_string, struct HE_EditMesh *em);
char *HE_SoftEdgeTool(char *arg_string, struct HE_EditMesh *em);
char *HE_BridgeTool(char *arg_string, struct HE_EditMesh *em);
												  /*for testing purposes only. . .*/
char *HE_GrabTool(char *arg_string,struct  HE_EditMesh *em);
char *HE_DeselSelTool(char *arg_string, struct HE_EditMesh *em);

/* Macro record functions */
struct ListBase *he_get_record_stack(void);
int he_get_record_status(void);
void HE_free_tool_record(void);
void HE_record_menu(void);

/*ok, these functions are used for things like extrude in place of transform['n']*/
void HED_Init_Drag(int type, float *cent);
float HED_GetDragValuef(void);
float *HED_GetDragValue3f(void);
char *HE_GetDragHeaderPrint(void);
int HED_Check_Cancel(void);
void HET_SelOrDeselAll(void);
void HE_Border_Select(short min[2], short max[2], int selmode);
void HED_DoDraw(void (*drawfunc)(void *data), void *data);
void HED_SetHeaderPrint(char *str);

#define EXCLUDE_FROM_MACRO  1

#define DIS_FROM_START  1
#define ROT_FROM_START  2
#define LOC_OFFSET  3
#define MANUAL  4
#define DIS_FROM_CENTER 5						  /*returns a range from 0 to 1+*/
#endif											  /* _HE_TOOLS_H*/
