#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_meshHE_tools.h"
#include "BIF_space.h"
#include "blendef.h" 

#include "BLI_arithb.h"
#include "BKE_utildefines.h"
#include "BKE_displist.h"
#include "BKE_hemesh.h"

#include "DNA_hemesh_types.h"

#include "he_editmesh.h"
#include "he_tools.h"
#include "mydevice.h"
#include "math.h"
#include <string.h>


void HET_Average(void)
{
	HE_ExecToolFromString("Average", NULL);
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Average");
}

char *HE_AverageTool(char *arg_string, HE_EditMesh *em)
{
	
	HE_EditVert *eve;
	HE_EditEdge *eed;
	HE_EditEdgeInfo *ieed;
	
	float cen[3];
	
	if (!em) return NULL;
	
	for (eve=em->verts.first; eve; eve=eve->next) {
		eve->f1 = 0;
		eve->f2 = 0;
	} 
	
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		eed = ieed->e1;
		if ((eed->v1->f & SELECT) || (eed->v2->f & SELECT)) {
			VecAddf(cen, eed->v1->co, eed->v2->co);
			VecMulf(cen, 0.5f);
			/*We store averaged coordinate in ->no normal value*/
			if (eed->v1->f & SELECT) {
				if (eed->v1->f1 == 0) {VECCOPY(eed->v1->no, cen);}
				else VecAddf(eed->v1->no, eed->v1->no, cen);
				eed->v1->f1++;
			}
			if (eed->v2->f & SELECT) {
				if (eed->v2->f1 == 0) {VECCOPY(eed->v2->no, cen);}
				else VecAddf(eed->v2->no, eed->v2->no, cen);
				eed->v2->f1++;
			}
		}
	}
	
	for (eve=em->verts.first; eve; eve=eve->next) {
		if (eve->f & SELECT) {
			if (eve->f1 != 0) {
				VecMulf(eve->no, 1.0f/((float)eve->f1));
				VECCOPY(eve->co, eve->no);
			}
		}
	}
	
	/*recalculate (restore) the vertex normals*/
	HE_recalcnormals();
	return NULL;
}
