#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_meshHE_tools.h"
#include "BIF_space.h"

#include "blendef.h"
#include "BLI_arithb.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_utildefines.h"

#include "DNA_hemesh_types.h"

#include "he_editmesh.h"
#include "he_tools.h"
#include "he_error.h"
#include "mydevice.h"
#include "math.h"
#include <string.h>


void HET_Bridge(void)
{
	HE_ExecToolFromString("Bridge", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Bridge");
}

#if 0
/*DISABLEDangle between faces must be less then 90 degrees. . .*/
/* d = f1->nor[0] * f2->nor[0] + f1->nor[1] * f2->nor[1] + f1->nor[2] * f2->nor[2];
   d = acosf(d);
   if (d < 3.141592654) {*//*180 degrees in radians, happens to be pi too :)*/
/*	HE_RaiseErrorString("Angle between faces must be less then 180 degrees!");
	return NULL;
	}*/

eed = f2->edge;
start = eed;
/*calculate whether to go backward or forwards. . .*/
x = eed->enext->v1->co[0] - vlist1[1]->co[0];
y = eed->enext->v1->co[1] - vlist1[1]->co[1];
z = eed->enext->v1->co[2] - vlist1[1]->co[2];
last_d = sqrt(x*x+y*y+z*z);

x = eed->eprev->v1->co[0] - vlist1[1]->co[0];
y = eed->eprev->v1->co[1] - vlist1[1]->co[1];
z = eed->eprev->v1->co[2] - vlist1[1]->co[2];
d = sqrt(x*x+y*y+z*z);

if (d < last_d) prev = 1;
else prev = 0;
//if (prev==0) c = convex(start->v1->co, vlist1[0]->co, vlist1[1]->co, start->enext->v1->co);
//else c = convex(start->v1->co, vlist1[0]->co, vlist1[1]->co, start->eprev->v1->co);

if (0) {
	eed = start;
	i=0;
	do {
		if (i != len-1) c = convex(eed->v1->co, vlist1[i]->co, vlist1[i+1]->co, eed->enext->v1->co);
		else c = convex(eed->v1->co, vlist1[i]->co, vlist1[0]->co, eed->enext->v1->co);
		
		if (!c) {
			if (i != len-1) c = convex(eed->v1->co, vlist1[i]->co, vlist1[i+1]->co, eed->eprev->v1->co);
			else c = convex(eed->v1->co, vlist1[i]->co, vlist1[0]->co, eed->eprev->v1->co);
		}
		if (c) { 
			printf("convex!\n"); 
			//start = eed;
			break;
		}
		eed=eed->enext;
		i++;
	} while (eed != start);
}

//c = convex(start->v1->co, vlist1[0]->co, vlist1[1]->co, start->enext->v1->co);
//s = convex(eed->v1->co, vlist1[0]->co, vlist1[1]->co, eed->eprev->v1->co);
//if (c) prev = 0;
//else prev = 1;
#endif

char *HE_BridgeTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditFace *efa, *f1=NULL, *f2=NULL, *newfa;
	HE_EditEdge *eed, *start;
	HE_EditVert *vlist1[6000], *vlist2[6000], *quad[4];
	float x, y, z, d, last_d;
	int i, len, len2, f, mat;
	int prev=0;
	
	if (!em) return NULL;
	
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->f & SELECT) {
			if (!f1) f1 = efa;
			else if (!f2) f2 =efa;
			else {
				HE_RaiseError(HE_INVALID_SELECTION);
				return NULL;
			}
		}
	}
	
	/*test faces. . .*/
	if ((!f2) || (!f1)) {
		HE_RaiseError(HE_INVALID_SELECTION);
		return NULL;
	}
	
	
	/*make sure faces arn't adjacent. . .*/
	eed = f1->edge;
	do {
		if ((eed->pair) && (eed->pair->face == f2)) {
			HE_RaiseErrorString("Faces must not be adjacent to each other!");
			return NULL;
		}
		eed=eed->enext;
	} while (eed != f1->edge);
	
	eed = f1->edge;
	len = 0;
	do {
		vlist1[len] = eed->v1;
		len++;
		eed=eed->enext;
	} while (eed != f1->edge);
	
	last_d = -1;
	d = 0;
	i = 0;
	eed = f2->edge;
	start = eed;
	do {
		x = eed->v1->co[0] - vlist1[0]->co[0];
		y = eed->v1->co[1] - vlist1[0]->co[1];
		z = eed->v1->co[2] - vlist1[0]->co[2];
		d = sqrt(x*x+y*y+z*z);
		printf("d: %f\n", d);
		if ((d < last_d) || last_d==-1) {
			start = eed;
			printf("d: %f\n", d);
			last_d = d;
		}
		eed=eed->enext;
		i++;
	} while (eed != f2->edge);
	start->v1->f |= SELECT;
	vlist1[0]->f |= SELECT;
	
	x = start->enext->v1->co[0] - vlist1[1]->co[0];
	y = start->enext->v1->co[1] - vlist1[1]->co[1];
	z = start->enext->v1->co[2] - vlist1[1]->co[2];
	last_d = sqrt(x*x+y*y+z*z);
	
	x = start->eprev->v1->co[0] - vlist1[1]->co[0];
	y = start->eprev->v1->co[1] - vlist1[1]->co[1];
	z = start->eprev->v1->co[2] - vlist1[1]->co[2];
	d = sqrt(x*x+y*y+z*z);
	
	if (d < last_d) prev = 1;
	else prev = 0;
	
	
	
	eed = start;
	len2 = 0;
	do {
		vlist2[len2] = eed->v1;
		if (prev) eed=eed->eprev;
		else eed=eed->enext;
		len2++;
	} while (eed != start);
	
	if (len2 != len) {
		HE_RaiseError(HE_SEL_MUST_BE_SAME);
		return NULL;
	}   
	/*OR together the two faces's flags, and copy face #1's mat.  .*/
	mat = f1->mat;
	f = f1->f | f2->f;
	
	/*delete faces*/ 
	HE_delete_face(em, f1);
	HE_delete_face(em, f2);
	
	HE_delete_face(em, f1);
	HE_delete_face(em, f2);
	
	vlist1[0]->f |= SELECT;
	vlist2[0]->f |= SELECT;
	
	for (i=0; i<len; i++) {
		quad[0] = vlist1[i];
		quad[1] = vlist2[i];
		if (i != len-1) quad[2] = vlist2[i+1];
		else quad[2] = vlist2[0];
		if (i != len-1) quad[3] = vlist1[i+1];
		else quad[3] = vlist1[0];
		
		newfa = HE_addfacelist(em, quad, 4);
		newfa->f = f & ~SELECT;
		newfa->mat = mat;
	}
	
	check_faces(em);
	return NULL;
}
