#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_space.h"
#include "BLI_arithb.h"
#include "BIF_interface.h"
#include "BIF_screen.h"
#include "BSE_view.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_utildefines.h"

#include "BDR_drawobject.h"

#include "he_editmesh.h"
#include "mydevice.h"
#include "he_tools.h"
#include "math.h"
#include "blendef.h" 
#include <string.h>

typedef struct _drag {
	int type;
	short smval[2];
	float val;
	float val3f[3];
	float cent[2];
	float cent3d[3]; /*for helpline. . .*/
	int cancel;
	int end;
	char *header;
} he_dragger;

static he_dragger m_drag;

void HED_Set_Manual_Value(float val)
{
	m_drag.val = val;
}

void HED_Init_Drag(int type, float *cent)
{
	unsigned short event;
	short val;
	
	getmouseco_areawin(m_drag.smval);
	m_drag.type = type;
	m_drag.val = 0;
	m_drag.cancel = 0;
	m_drag.end = 0;
	m_drag.header = NULL;
	if (cent) {
		project_float(cent, m_drag.cent);
		VECCOPY(m_drag.cent3d, cent);
	} else {
		m_drag.cent3d[0] = m_drag.cent3d[1] = m_drag.cent3d[2] = 0;
		project_float(m_drag.cent3d, m_drag.cent);
	}	 
	/*empty event queue. . .*/
	while( qtest() ) {
		event= extern_qread(&val);
	}
}

void HED_DoDraw(void (*drawfunc)(void *data), void *data)
{
	char hstr[64] = "";
	
	scrarea_do_windraw(curarea);
	
	if (drawfunc) drawfunc(data);
	if (m_drag.type != DIS_FROM_START) helpline(m_drag.cent3d);
	
	if (m_drag.header) headerprint(m_drag.header);
	else { 
		sprintf(hstr, "Val: %f", m_drag.val);
		headerprint(hstr);
	}
	helpline(m_drag.cent3d);
	
	screen_swapbuffers();
}

/* SCRATCH THAT IDEA--> as a precaution, on user cancel the value 1 is fired to
   to restore data to previous state (although of course the function
   code can do it, too). */

/*returns: 1 on success, 2 on cancel*/
int HED_Check_Cancel(void)
{
	short mval[2], val=0;
	unsigned short event=0;
	float x,y;
	float dis1, dis2;
	
	if (m_drag.cancel == 1) {
		return 2;
	} else if (m_drag.end==1) 
		return 1;
 	else { 	/*calculate val. . .*/
 		while (qtest()) {
			event = extern_qread(&val);
	 		/*ooh, we're done!*/
	 		if (event==LEFTMOUSE && val==1) {
	 			m_drag.end = 1;
	 			//printf("QVal: %d\n", (int)val);
	 			return 1;
	 		} else if (event==RIGHTMOUSE || event==ESCKEY) {
	 			m_drag.cancel = 1;
	 			return 0;
 			}
		}
		
 		getmouseco_areawin(mval);
		switch (m_drag.type) {
			case DIS_FROM_CENTER:
				dis1 = sqrt(pow((float)(mval[0]-m_drag.cent[0]), 2)+pow((float)(mval[1]-m_drag.cent[1]),2));
				dis2 = sqrt(pow((float)(m_drag.smval[0]-m_drag.cent[0]),2)+pow((float)(m_drag.smval[1]-m_drag.cent[1]),2));
				dis1 = (dis1 / dis2);
				m_drag.val = dis1;
				break;
			case DIS_FROM_START:
				x = m_drag.smval[0]-mval[0];
				y = m_drag.smval[1]-mval[1];
				m_drag.val = sqrt(x*x+y*y);
				break;
			case LOC_OFFSET:
				window_to_3d(m_drag.val3f, mval[0] - m_drag.smval[0], mval[1] - m_drag.smval[1]);
				break;
		}
	}
	return 0;
}

float HED_GetDragValuef(void)
{
	return m_drag.val;
}

float *HE_GetDragValue3f(void)
{
	return m_drag.val3f;
}

void HED_SetHeaderPrint(char *str)
{
	m_drag.header = str;
}

char *HED_GetDragHeaderPrint(void)
{
	return m_drag.header;
}
