#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_space.h"
#include "blendef.h" 
#include "BLI_arithb.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_utildefines.h"

#include "he_editmesh.h"
#include "he_tools.h"
#include "he_error.h"
#include "mydevice.h"

#include "math.h"
#include <string.h>

/*
  Various selection tools
*/

void HET_HideSel(void)
{
	HE_ExecToolFromString("Hide Sel", NULL);
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Hide Sel");
}

char *HE_HideSelTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditVert *eve;
	HE_EditFace *efa;
	HE_EditEdgeInfo *ieed;
	HE_EditEdge *eed;

	if (!em) return NULL;

	/*clear flags. . .*/
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		ieed->f1 = 0;
		ieed->e1->f1 = 0;
		if (ieed->e2) ieed->e2->f1 = 0;
		ieed->e1->v1->f1 = 0;
		ieed->e1->v2->f1 = 0;
		ieed->e1->face->f1 = 0;
	}
	/*we always start at faces. . .*/
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->f & SELECT) {
			efa->h = 2;
			eed = efa->edge;
			do {
				eed->ieed->f1 = 1;
				eed->v1->f1 = 1;
				eed=eed->enext;
			} while (eed != efa->edge);
		}
		if (efa->h) efa->f &= ~SELECT;
	}


	for (eve=em->verts.first; eve; eve=eve->next) {
		if ((eve->f & SELECT) || eve->f1==1) {
			if (eve->f & SELECT) eve->h = 2;
			else eve->h = 1;
			eve->f &= ~SELECT;
		} 
	}
	
	/*now edges. . .*/
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		if (ieed->f1 == 1) {
		   	ieed->h = 2;
		   	ieed->f &= ~SELECT;
		} else if ((ieed->f & SELECT) || ieed->e1->v1->h || ieed->e1->v2->h) {
			if (ieed->f & SELECT) ieed->h = 2;
			else ieed->h = 1;
			if (!ieed->e1->face->h) ieed->e1->face->h = 1;
			if (ieed->e2 && !ieed->e2->face->h) ieed->e2->face->h = 1;
		}
	}
	
	return NULL;
}

void HET_RevealSel(void)
{
	HE_ExecToolFromString("Reveal Sel", NULL);
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Reveal Sel");
}

char *HE_RevealSelTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditVert *eve;
	HE_EditFace *efa;
	HE_EditEdgeInfo *ieed;
	HE_EditEdge *eed;

	if (!em) return NULL;

	/*we always start at verts. . .*/
	for (eve=em->verts.first; eve; eve=eve->next) {
		if (eve->h==2) eve->f |= SELECT;
		eve->h = 0;
	}
	/*now edges. . .*/
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		if (ieed->h==2) ieed->f |= SELECT;
	   	ieed->h = 0;
	}
	/*now faces. . .*/
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->h==2) efa->f |= SELECT;
		efa->h = 0;

	}
	return NULL;
}
