#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_space.h"
#include "blendef.h" 

#include "BLI_arithb.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_utildefines.h"

#include "DNA_hemesh_types.h"

#include "he_error.h"
#include "he_tools.h"
#include "he_editmesh.h"
#include "mydevice.h"

#include "math.h"
#include <string.h>

void HET_Joinfaces(void)
{
	HE_ExecToolFromString("JoinFaces", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);

	DAG_object_flush_update(G.scene, G.obedit, OB_RECALC_DATA);

	BIF_undo_push("Join Faces");
}

char *HE_JoinFacesTool(char *arg_string, HE_EditMesh *em)
{
	
	HE_EditFace **faces;
	HE_EditVert *eve;
	int i;
	
	if (!em) return NULL;
	
	for (eve=em->verts.first; eve; eve=eve->next) {
		if (eve->f & SELECT) {
			faces = he_getFacesAroundVert(em, eve);
			if (!faces) return NULL;
			i = 0;
			while (faces[i] != NULL) {
				HE_select_face(faces[i]);
				i++;
			}
			break;
		}
	}
	
	return NULL;   
}
