#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_space.h"
#include "blendef.h" 
#include "BLI_arithb.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_utildefines.h"

#include "he_editmesh.h"
#include "he_error.h"
#include "string.h"
#include "mydevice.h"
#include "math.h"
#include <string.h>


char *HE_SelectMatTool(char *arg_string, HE_EditMesh *em)
{
	HE_Mesh *me = G.obedit->data;
	
	HE_EditFace *efa;
	char *s;
	int i, dosel;
	
	if (!em || !arg_string) {
		HE_RaiseError(HE_BAD_ARGUMENT_STRING);
		return NULL;
	}
	
	sscanf(arg_string, "%d %d", &i, &dosel);
	
	if (i > me->totcol || i < 0) {
		HE_RaiseError(HE_BADINDEX);
		printf("Bad mat index: %d\n", i);
		return NULL;
	}
	
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->mat==i) {
			if (dosel) HE_select_face(efa);
			else HE_deselect_face(efa);
		}		
	}
	
	/*make a copy for freeN safeness. . .*/
	s = MEM_callocN(strlen(arg_string)+1, "arg_string_assignmattool");
	memcpy(s, arg_string, strlen(arg_string));
	return s;
}

char *HE_AssignMatTool(char *arg_string, HE_EditMesh *em)
{
	HE_Mesh *me = G.obedit->data;
	
	HE_EditFace *efa;
	char *s;
	int i;
	
	if (!em || !arg_string) {
		HE_RaiseError(HE_BAD_ARGUMENT_STRING);
		return NULL;
	}
	
	sscanf(arg_string, "%d", &i);
	
	if (i > me->totcol || i < 0) {
		HE_RaiseError(HE_BADINDEX);
		printf("Bad mat index: %d\n", i);
		return NULL;
	}
	
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->f & SELECT) {
			efa->mat = i;
		}		
	}
	
	/*make a copy for freeN safeness. . .*/
	s = MEM_callocN(strlen(arg_string)+1, "arg_string_assignmattool");
	memcpy(s, arg_string, strlen(arg_string));
	return s;
}
