#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_space.h"
#include "blendef.h" 
#include "BLI_arithb.h"
#include "BKE_utildefines.h"
#include "DNA_scene_types.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_utildefines.h"

#include "he_editmesh.h"
#include "he_tools.h"
#include "he_error.h"
#include "mydevice.h"
#include "math.h"
#include <string.h>


void HET_Merge(void)
{
	HE_ExecToolFromString("Merge", NULL);
	HE_recalcnormals();
	allqueue(REDRAWVIEW3D, 1);

	DAG_object_flush_update(G.scene, G.obedit, OB_RECALC_DATA);

	BIF_undo_push("Merge");
	G.scene->selectmode |= SCE_SELECT_VERTEX; /*we have to be in vertex selmode*/
}

/*This functions works by merging then remakeing an HE Mesh
  This method is ultimately the best one, IMHO, because although it
  is really inelegant, it does result in what seems to be a more
  intuitive user tool.*/
char *HE_MergeTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditMesh *oldem;
	HE_EditVert *v1=NULL, *eve, *vlist[5000];
	HE_EditEdge *eed, *e1=NULL, *e2=NULL;
	HE_EditEdgeInfo *ieed;
	HE_EditFace *efa, *newfa;
	float co[3] = {0, 0, 0};
	int len = 0, i=0;
	
	for (eve=em->verts.first; eve; eve=eve->next) {
		if (eve->f & SELECT) {
			VecAddf(co, co, eve->co);
			len++;
			eve->f1 = 1;
		} else eve->f1 = 0;
		eve->f2 = 0;
		eve->f3 = 0;
		eve->newvert = NULL;
	}
	if (len) VecMulf(co, 1.0f/((float)len));
	v1 = HE_addvertlist(em, co);
	v1->f |= SELECT;
	v1->f1 = 0;
	
	/*merge the verts. . .*/
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		e1 = ieed->e1;
		e2 = ieed->e2;
		if (e1->v1->f1==1) e1->v1 = v1;
		if (e1->v2->f1==1) e1->v2 = v1;
		if (e2) {
			if (e2->v1->f1==1) e2->v1=v1;
			if (e2->v2->f1==1) e2->v2=v1;
		}
	}
	/*now it's remake-the-mesh time!*/
	/*temp structure. . .*/
	oldem = MEM_dupallocN(em);
	
	/*clear mesh of all references. . .
	  we have them saved in oldem for now.*/
	memset(em, 0, sizeof(HE_EditMesh));
	
	for (efa=oldem->faces.first; efa; efa=efa->next) {
		eed = efa->edge;
		i=0;
		do {
			if (eed->v1 != eed->enext->v1) {
				if (!eed->v1->newvert) {
					eve = HE_addvertlist(em, eed->v1->co);
					eve->f = eed->v1->f;
					eed->v1->newvert = eve;
				} else eve = eed->v1->newvert;
				
				vlist[i] = eve;
				i++;
			}
			eed=eed->enext;
		} while (eed != efa->edge);
		
		if (i < 3) continue; /*it's less then a triangle*/
		newfa = HE_addfacelist(em, vlist, i);
		newfa->f = efa->f & ~SELECT;
		newfa->mat = efa->mat;
		/*restore creases*/
		eed = efa->edge;
		e2 = newfa->edge;
		do {
			e2->ieed->crease = eed->ieed->crease;
			e2->ieed->seam = eed->ieed->seam;
			
			eed=eed->enext;
			e2=e2->enext;
		} while (eed != efa->edge);
		/*I don't think this is a good idea, could allow
		  non-manifold errors.
		  if (HE_CatchError(HE_NON_MANIFOLD)) {
		  while (HE_CatchError(HE_NON_MANIFOLD));
		  HE_delete_face(em, newfa);
		  }*/  
	}
	
	check_faces(em);
	
	/*delete the old mesh. . .*/
	he_free_HEEditMesh(oldem);
	return NULL; 
}
