#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h" 
#include "BIF_meshHE_tools.h"

#include "BIF_space.h"
#include "blendef.h"
#include "BLI_arithb.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_main.h"
#include "BKE_utildefines.h"

#include "DNA_hemesh_types.h"

#include "he_editmesh.h"
#include "he_error.h"
#include "he_tools.h"
#include "mydevice.h"
#include "math.h"
#include <string.h>


void HET_HardEdge(void)
{
	HE_ExecToolFromString("Hard Edge", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Hard Edge");
}

void HET_SoftEdge(void)
{
	HE_ExecToolFromString("Soft Edge", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Soft Edge");
}

void HET_SolidShade(void)
{
	HE_ExecToolFromString("SolidShade", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Solid Shade");
}

void HET_SmoothShade(void)
{
	HE_ExecToolFromString("SmoothShade", NULL);
	HE_recalcnormals();
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Smooth Shade");
}

char *HE_HardEdgeTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditEdgeInfo *ieed;
	if (!em) return NULL;
	
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		if (ieed->f & SELECT) {
			ieed->f |= HEM_HARD;
		}
	}
	
	return NULL;
}

char *HE_SoftEdgeTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditEdgeInfo *ieed;
	if (!em) return NULL;
	
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		if (ieed->f & SELECT) {
			ieed->f &= ~HEM_HARD;
		}
	}
	
	return NULL;
}

char *HE_SmoothShadeTool(char *arg_string, HE_EditMesh *em)
{  
	HE_EditFace *efa;
	
	if (!em) return NULL;
	
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->f & SELECT) {
			efa->f |= HEM_SMOOTH;
		}
	}
	
	
	return NULL;
}

char *HE_SolidShadeTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditFace *efa;
	
	if (!em) return NULL;
	
	for (efa=em->faces.first; efa; efa=efa->next) {
		if (efa->f & SELECT) {
			efa->f &= ~HEM_SMOOTH;
		}
	}
	
	return NULL;
}	  
