#include <stdio.h>
#include "MEM_guardedalloc.h"
#include "BIF_meshHE.h"
#include "BIF_space.h"
#include "blendef.h" 
#include "BLI_arithb.h"

#include "BKE_displist.h"
#include "BKE_hemesh.h"
#include "BKE_global.h"
#include "BKE_main.h"
#include "BKE_utildefines.h"

#include "he_editmesh.h"
#include "he_error.h"
#include "he_tools.h"
#include "mydevice.h"
#include "math.h"
#include <string.h>


void HET_Subdivide(void)
{
	HE_ExecToolFromString("Subdivide", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Subdivide");
}

void HET_SubdivideSmooth(void)
{
	HE_ExecToolFromString("Subdivide Smooth", NULL);
	HE_recalcnormals();
	
	allqueue(REDRAWVIEW3D, 1);
	BIF_undo_push("Subdivide Smooth");
}

/*this directly calls two tool functions because it makes
  sense*/
char *HE_SubdivSmoothTool(char *arg_string, HE_EditMesh *em)
{
	HE_SubdivideTool(NULL, em);
	HE_AverageTool(NULL, em);
	HE_AverageTool(NULL, em);
	HE_AverageTool(NULL, em);
	return NULL;
}

/* this function is not used anywhere, but it may be needed*/
HE_EditVert *del_then_split_edge(HE_EditEdge *eed, HE_EditMesh *em)
{
	HE_EditFace *efa;
	HE_EditEdge *eedr;
	HE_EditVert *vlist[6000], *eve;
	int i=0, f=0;
	float co[3];
	
	VecAddf(co, eed->v1->co, eed->enext->v1->co);
	VecMulf(co, 0.5f);
	eve = HE_addvertlist(em, co);
	
	efa = eed->face;
	f = efa->f;
	eedr = efa->edge;
	do {
		i = 0;
		if (eedr==eed) {
			vlist[i] = eedr->v1;
			i++;
			vlist[i] = eve;
		} else vlist[i] = eedr->v1;
		i++; 
		eedr=eedr->enext;
	} while (eedr != efa->edge);
	
	HE_delete_face(em, efa);
 	efa = HE_addfacelist(em, vlist, i);
	efa->f = f;
	return eve;  
}

char *HE_SubdivideTool(char *arg_string, HE_EditMesh *em)
{
	HE_EditVert *vlist[6000], *vlist2[4], *cent;
	HE_EditEdge *eed;
	HE_EditEdgeInfo *ieed;
	HE_EditFace *efa, *newfa, *next;
	int i, vlen, f, mat;
	
	if (!em) return NULL;
	/* Clear flags. . .*/
	for (eed=em->edges.first; eed; eed=eed->next) {
		eed->f1 = 0;
		eed->f2 = 0;
		eed->ieed->f1 = 0;
	}
	for (efa=em->faces.first; efa; efa=efa->next) efa->f1 = 0;
	
	/* . . .and subdivide */
	for (efa=em->faces.last; efa; efa=next) {
		next = efa->prev;
		if ((efa->f & SELECT) && efa->f1==0) {
			f = efa->f;
			mat = efa->mat;
			cent = HE_addvertlist(em, efa->cent);
			eed = efa->edge;
			i = 0;
			do {
				if (!eed->f2) split_edge(em, eed);
				eed=eed->eprev;
			} while (eed != efa->edge && eed->f1 != 1);
			eed = efa->edge;
			vlen = 0;
			do {
				vlist[vlen] = eed->v1;
				//printf("vlen: %d\n", vlen);
				vlen++;
				eed=eed->enext;
			} while (eed != efa->edge);
			HE_delete_face(em, efa);
			
			for (i=0; i<vlen; i += 2) {
				vlist2[0] = vlist[i];
				if (i < vlen-1) vlist2[1] = vlist[i+1];
				else vlist2[1] = vlist[0];
				vlist2[2] = cent;
				if (i > 0) vlist2[3] = vlist[i-1];
				else vlist2[3] = vlist[vlen-1];
				
				newfa = HE_addfacelist(em, vlist2, 4);
				eed = newfa->edge;
				do {
					eed->ieed->f1 = 1;
					eed=eed->enext;
				} while (eed != newfa->edge);
				if (f & SELECT) HE_select_face(newfa);
				newfa->f = f;
				newfa->f1 = 2;
				newfa->mat = mat;
			}
		}
	}  
	for (ieed=em->einfo.first; ieed; ieed=ieed->next) {
		if ((ieed->f & SELECT) && ieed->f1==0) {
			split_edge(em, ieed->e1);
		}
	} 
	return NULL;	 
}
