/**
 * $Id: BSE_headerbuttons.h 1376 2005-07-29 14:01:19Z broken $
 *
 * ***** BEGIN GPL/BL DUAL LICENSE BLOCK *****
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. The Blender
 * Foundation also sells licenses for use in proprietary software under
 * the Blender License.  See http://www.blender.org/BL/ for information
 * about this.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The Original Code is Copyright (C) 2001-2002 by NaN Holding BV.
 * All rights reserved.
 *
 * The Original Code is: all of this file.
 *
 * Contributor(s): none yet.
 *
 * ***** END GPL/BL DUAL LICENSE BLOCK *****
 */

#ifndef BSE_HEADERBUTTONS_H
#define BSE_HEADERBUTTONS_H


/* defines for the big list of view3d header tools */
#pragma mark -
#pragma mark View3d Menu Event Codes
#pragma mark -

/* ****** XXX WARNING: These are saved in file, do not change the order!
 * To add a new tool, add the define *below* the others in each group, and be sure to 
 * leave plenty of space for expansion! */

/* General convention so far - leave:
 * 40 spaces for a top level menu,
 * 20 spaces for a submenu,
 * 150~ spaces for extra submenus, python, etc. */

enum View3DEventCodes {
#pragma mark View Menu
	
	/* View menu */
	B_V3D_VIEW = 100,
	
	B_V3D_VIEW_BACKGROUNDIMAGE,
	B_V3D_VIEW_VIEWPROPERTIES,
	B_V3D_VIEW_TOOLBAR,
	
	B_V3D_VIEW_USER = 110,
	B_V3D_VIEW_CAMERA,
	B_V3D_VIEW_TOP,
	B_V3D_VIEW_BOTTOM,
	B_V3D_VIEW_FRONT,
	B_V3D_VIEW_BEHIND,
	B_V3D_VIEW_LEFT,
	B_V3D_VIEW_RIGHT,
	B_V3D_VIEW_PERSPECTIVE,
	B_V3D_VIEW_ORTHO,
	B_V3D_VIEW_LOCALVIEW,
	B_V3D_VIEW_GLOBALVIEW,
	B_V3D_VIEW_VIEWSELECTED,
	B_V3D_VIEW_VIEWALL,
	B_V3D_VIEW_MAXIMIZETILE,
	B_V3D_VIEW_PLAYBACKANIM,
	
	B_V3D_VIEW_MENU = 140,
	
	/* Camera Controls */
	B_V3D_VIEW_ORBITLEFT,
	B_V3D_VIEW_ORBITRIGHT,
	B_V3D_VIEW_ORBITUP,
	B_V3D_VIEW_ORBITDOWN,
	B_V3D_VIEW_PANLEFT,
	B_V3D_VIEW_PANRIGHT,
	B_V3D_VIEW_PANUP,
	B_V3D_VIEW_PANDOWN,
	B_V3D_VIEW_ZOOMIN,
	B_V3D_VIEW_ZOOMOUT,
	B_V3D_VIEW_RESETZOOM,
	
	B_V3D_VIEW_CAMERACONTROLSMENU = 160,
	
	/* Align View */
	B_V3D_VIEW_CENTERVIEWCURSOR,
	B_V3D_VIEW_CENTERCURSORVIEWALL,
	B_V3D_VIEW_ALIGNCAMERATOVIEW,
	B_V3D_VIEW_ALIGNVIEWSELECTEDTOP,
	B_V3D_VIEW_ALIGNVIEWSELECTEDFRONT,
	B_V3D_VIEW_ALIGNVIEWSELECTEDSIDE,
	B_V3D_VIEW_ALIGNVIEWSELECTED,
	
	B_V3D_VIEW_ALIGNVIEWMENU = 180,
	
#pragma mark - Object Mode
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_OB = 300,
	
	B_V3D_SEL_OB_BORDER,
	B_V3D_SEL_OB_SELDESELALL,
	
	B_V3D_SEL_OB_MENU = 340,
	
	/* By Layer */
	B_V3D_SEL_OB_LAYER1,
	B_V3D_SEL_OB_LAYER2,
	B_V3D_SEL_OB_LAYER3,
	B_V3D_SEL_OB_LAYER4,
	B_V3D_SEL_OB_LAYER5,
	B_V3D_SEL_OB_LAYER6,
	B_V3D_SEL_OB_LAYER7,
	B_V3D_SEL_OB_LAYER8,
	B_V3D_SEL_OB_LAYER9,
	B_V3D_SEL_OB_LAYER10,
	B_V3D_SEL_OB_LAYER11,
	B_V3D_SEL_OB_LAYER12,
	B_V3D_SEL_OB_LAYER13,
	B_V3D_SEL_OB_LAYER14,
	B_V3D_SEL_OB_LAYER15,
	B_V3D_SEL_OB_LAYER16,
	B_V3D_SEL_OB_LAYER17,
	B_V3D_SEL_OB_LAYER18,
	B_V3D_SEL_OB_LAYER19,
	B_V3D_SEL_OB_LAYER20,
	
	B_V3D_SEL_OB_BYLAYERMENU = 370,
	
	/* By Type */
	B_V3D_SEL_OB_TYPEMESH,
	B_V3D_SEL_OB_TYPECURVE,
	B_V3D_SEL_OB_TYPESURF,
	B_V3D_SEL_OB_TYPEMBALL,
	B_V3D_SEL_OB_TYPEFONT,
	B_V3D_SEL_OB_TYPEHEMESH,
	B_V3D_SEL_OB_TYPEARMATURE = 380, /* space for more object types */
	B_V3D_SEL_OB_TYPELATTICE,
	B_V3D_SEL_OB_TYPEEMPTY,
	B_V3D_SEL_OB_TYPECAMERA,
	B_V3D_SEL_OB_TYPELAMP,
	
	B_V3D_SEL_OB_BYTYPEMENU = 400,

	/* Linked */
	B_V3D_SEL_OB_LINKEDOBJECTIPO,
	B_V3D_SEL_OB_LINKEDOBDATA,
	B_V3D_SEL_OB_LINKEDMATERIAL,
	B_V3D_SEL_OB_LINKEDTEXTURE,

	B_V3D_SEL_OB_LINKEDMENU = 420,

	/* Grouped */
	B_V3D_SEL_OB_GROUPEDCHILDREN,
	B_V3D_SEL_OB_GROUPEDIMMEDIATECHILDREN,
	B_V3D_SEL_OB_GROUPEDPARENT,
	B_V3D_SEL_OB_GROUPEDSHAREDLAYERS,
	
	B_V3D_SEL_OB_GROUPEDMENU = 440,

#pragma mark Global Transform Menus
	/* Transform */
	B_V3D_ED_TFM = 800,
	

	B_V3D_ED_TFM_TRANSLATION_XGLOBAL,
	B_V3D_ED_TFM_TRANSLATION_YGLOBAL,
	B_V3D_ED_TFM_TRANSLATION_ZGLOBAL,
	B_V3D_ED_TFM_TRANSLATION_XLOCAL,
	B_V3D_ED_TFM_TRANSLATION_YLOCAL,
	B_V3D_ED_TFM_TRANSLATION_ZLOCAL,
	
	B_V3D_ED_TFM_TRANSLATION_MENU = 820,

	B_V3D_ED_TFM_ROTATION_XGLOBAL,
	B_V3D_ED_TFM_ROTATION_YGLOBAL,
	B_V3D_ED_TFM_ROTATION_ZGLOBAL,
	B_V3D_ED_TFM_ROTATION_XLOCAL,
	B_V3D_ED_TFM_ROTATION_YLOCAL,
	B_V3D_ED_TFM_ROTATION_ZLOCAL,
	
	B_V3D_ED_TFM_ROTATION_MENU = 840,
	
	B_V3D_ED_TFM_RESIZE_XGLOBAL,
	B_V3D_ED_TFM_RESIZE_YGLOBAL,
	B_V3D_ED_TFM_RESIZE_ZGLOBAL,
	B_V3D_ED_TFM_RESIZE_XLOCAL,
	B_V3D_ED_TFM_RESIZE_YLOCAL,
	B_V3D_ED_TFM_RESIZE_ZLOCAL,
	
	B_V3D_ED_TFM_RESIZE_MENU = 860,
	
	B_V3D_ED_TFM_TRANSLATION = 900,
	B_V3D_ED_TFM_ROTATION,
	B_V3D_ED_TFM_RESIZE,
	
	B_V3D_ED_TFM_SHRINKFATTEN,
	B_V3D_ED_TFM_TOSPHERE,
	B_V3D_ED_TFM_SHEAR,
	B_V3D_ED_TFM_WARP,
	B_V3D_ED_TFM_PUSHPULL,
	
	B_V3D_ED_TFM_SCALETOIMAGEASPECT = 920,
	
	B_V3D_ED_TFM_OBDATATOCENTER = 930,
	B_V3D_ED_TFM_CENTERNEW,
	B_V3D_ED_TFM_CENTERCURSOR,
	
	B_V3D_ED_TFM_MENU = 990,

	/* Snap */
	B_V3D_ED_SNAP = 1100,
	
	B_V3D_ED_SNAP_SELECTION_GRID,
	B_V3D_ED_SNAP_SELECTION_CURSOR,
	B_V3D_ED_SNAP_CURSOR_GRID,
	B_V3D_ED_SNAP_CURSOR_SELECTION,
	B_V3D_ED_SNAP_SELECTION_CENTER,
	
	B_V3D_ED_SNAP_MENU = 1120,
	
#pragma mark Object Menu
	
	/* Object */
	B_V3D_ED_OB = 1500,
	
	B_V3D_ED_OB_TRANSFORMPROPERTIES,
	B_V3D_ED_OB_INSERTKEY,
	B_V3D_ED_OB_DUPLICATE,
	B_V3D_ED_OB_DUPLICATELINKED,
	B_V3D_ED_OB_DELETE,
	B_V3D_ED_OB_BOOLEAN,
	B_V3D_ED_OB_JOINOBJECTS,
	B_V3D_ED_OB_CONVERTOBJECTTYPE,
	B_V3D_ED_OB_MOVETOLAYER,
	
	B_V3D_ED_OB_MENU = 1540,
	
	B_V3D_ED_OB_MIRROR_XLOCAL,
	B_V3D_ED_OB_MIRROR_YLOCAL,
	B_V3D_ED_OB_MIRROR_ZLOCAL,
	
	B_V3D_ED_OB_MIRROR_MENU = 1560,
	
	B_V3D_ED_OB_CLEARAPPLY_APPLYSIZEROT,
	B_V3D_ED_OB_CLEARAPPLY_APPLYDEFORMATION,
	B_V3D_ED_OB_CLEARAPPLY_MAKEDUPLISREAL,
	B_V3D_ED_OB_CLEARAPPLY_CLEARLOCATION,
	B_V3D_ED_OB_CLEARAPPLY_CLEARROTATION,
	B_V3D_ED_OB_CLEARAPPLY_CLEARSIZE,
	B_V3D_ED_OB_CLEARAPPLY_CLEARORIGIN,
	
	B_V3D_ED_OB_CLEARAPPLY_MENU = 1580,
	
	B_V3D_ED_OB_MAKELINKS_TOSCENE,
	B_V3D_ED_OB_MAKELINKS_OBJECTIPO,
	B_V3D_ED_OB_MAKELINKS_OBDATA,
	B_V3D_ED_OB_MAKELINKS_MATERIALS,
	
	B_V3D_ED_OB_MAKELINKS_MENU = 1600,
	
	B_V3D_ED_OB_SINGLEUSER_OBJECT,
	B_V3D_ED_OB_SINGLEUSER_OBJECTOBDATA,
	B_V3D_ED_OB_SINGLEUSER_OBJECTOBDATAMATERIALS,
	B_V3D_ED_OB_SINGLEUSER_MATERIALSTEX,

	B_V3D_ED_OB_SINGLEUSER_MENU = 1620,
	
	B_V3D_ED_OB_COPYATTR_LOCATION,
	B_V3D_ED_OB_COPYATTR_ROTATION,
	B_V3D_ED_OB_COPYATTR_SIZE,
	B_V3D_ED_OB_COPYATTR_DRAWTYPE,
	B_V3D_ED_OB_COPYATTR_TIMEOFFSET,
	B_V3D_ED_OB_COPYATTR_DUPLI,

	B_V3D_ED_OB_COPYATTR_MASS,
	B_V3D_ED_OB_COPYATTR_DAMPING,
	B_V3D_ED_OB_COPYATTR_PROPERTIES,
	B_V3D_ED_OB_COPYATTR_LOGICBRICKS,
	
	B_V3D_ED_OB_COPYATTR_CONSTRAINTS,
	B_V3D_ED_OB_COPYATTR_TEXTURESPACE,
	B_V3D_ED_OB_COPYATTR_FONTSETTINGS,
	B_V3D_ED_OB_COPYATTR_BEVELSETTINGS,
	B_V3D_ED_OB_COPYATTR_SUBDIV,
	B_V3D_ED_OB_COPYATTR_PARTICLESETTINGS,
	B_V3D_ED_OB_COPYATTR_METASETTINGS,
	B_V3D_ED_OB_COPYATTR_MODIFIERS,
	
	B_V3D_ED_OB_COPYATTR_MENU = 1660,
	
	B_V3D_ED_OB_PARENT_MAKE,
	B_V3D_ED_OB_PARENT_CLEAR,
	
	B_V3D_ED_OB_PARENT_MENU = 1670,
	
	B_V3D_ED_OB_TRACK_MAKE,
	B_V3D_ED_OB_TRACK_CLEAR,
	
	B_V3D_ED_OB_TRACK_MENU = 1680,
	
	/* Scripts */
	B_V3D_ED_OB_SCRIPTS = 1800,

	B_V3D_ED_OB_SCRIPTSMENU = 1900,
	
#pragma mark -Edit Mode (Mesh)	
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_ME = 2500,
	
	B_V3D_SEL_ME_BORDERSELECT,
	B_V3D_SEL_ME_DESELECTALL,
	B_V3D_SEL_ME_INVERSE,
	B_V3D_SEL_ME_RANDOM,
	B_V3D_SEL_ME_NONMANIFOLD,
	B_V3D_SEL_ME_TRIANGLES,
	B_V3D_SEL_ME_QUADS,
	B_V3D_SEL_ME_NONTRIANGLESQUADS,
	B_V3D_SEL_ME_MORE,
	B_V3D_SEL_ME_LESS,
	B_V3D_SEL_ME_FACELOOP,
	B_V3D_SEL_ME_VERTEXLOOP,
	B_V3D_SEL_ME_LINKEDVERTICES,
	
	B_V3D_SEL_ME_MENU = 2540,

#pragma mark Global Proportional Edit Menu
	
	B_V3D_ED_PROP = 2700,
	
	B_V3D_ED_PROP_SMOOTH,
	B_V3D_ED_PROP_SPHERE,
	B_V3D_ED_PROP_ROOT,
	B_V3D_ED_PROP_SHARP,
	B_V3D_ED_PROP_LIN,
	B_V3D_ED_PROP_CONST,
	
	B_V3D_ED_PROP_MENU = 2720,
	
	B_V3D_ED_MIRROR_XGLOBAL,
	B_V3D_ED_MIRROR_YGLOBAL,
	B_V3D_ED_MIRROR_ZGLOBAL,
	B_V3D_ED_MIRROR_XLOCAL,
	B_V3D_ED_MIRROR_YLOCAL,
	B_V3D_ED_MIRROR_ZLOCAL,
	B_V3D_ED_MIRROR_XVIEW,
	B_V3D_ED_MIRROR_YVIEW,
	B_V3D_ED_MIRROR_ZVIEW,
	
	B_V3D_ED_MIRROR_MENU = 2740,
	
#pragma mark Mesh Menu
	
	/* Mesh */
	B_V3D_ED_ME = 2800,
	
	B_V3D_ED_ME_UNDOEDITING,
	B_V3D_ED_ME_REDOEDITING,
	B_V3D_ED_ME_TRANSFORMPROPERTIES,
	B_V3D_ED_ME_INSERTKEY,
	B_V3D_ED_ME_EXTRUDE,
	B_V3D_ED_ME_DUPLICATE,
	B_V3D_ED_ME_MAKEEDGEFACE,
	B_V3D_ED_ME_DELETE,
	B_V3D_ED_ME_PROPORTIONALEDITING,
	
	B_V3D_ED_ME_MENU = 2840,
	
	B_V3D_ED_ME_VERTICES_MERGE,
	B_V3D_ED_ME_VERTICES_SPLIT,
	B_V3D_ED_ME_VERTICES_SEPARATE,
	B_V3D_ED_ME_VERTICES_SMOOTH,
	B_V3D_ED_ME_VERTICES_NOISE,
	B_V3D_ED_ME_VERTICES_REMOVEDOUBLES,
	B_V3D_ED_ME_VERTICES_HASH,
	B_V3D_ED_ME_VERTICES_XSORT,
	B_V3D_ED_ME_VERTICES_MAKEVERTEXPARENT,
	B_V3D_ED_ME_VERTICES_ADDHOOK,
	B_V3D_ED_ME_VERTICES_SOFTENVERTEXGROUP,
	
	B_V3D_ED_ME_VERTICES_MENU = 2880,
	
	B_V3D_ED_ME_EDGES_MAKEEDGEFACE,
	B_V3D_ED_ME_EDGES_BEVEL,
	B_V3D_ED_ME_EDGES_LOOPSUBDIVIDE,
	B_V3D_ED_ME_EDGES_KNIFESUBDIVIDE,
	B_V3D_ED_ME_EDGES_SUBDIVIDE,
	B_V3D_ED_ME_EDGES_SUBDIVIDEFRACTAL,
	B_V3D_ED_ME_EDGES_SUBDIVIDESMOOTH,
	B_V3D_ED_ME_EDGES_MARKSEAM,
	B_V3D_ED_ME_EDGES_CLEARSEAM,
	B_V3D_ED_ME_EDGES_CREASESUBSURF,
	B_V3D_ED_ME_EDGES_ROTATEEDGECW,
	B_V3D_ED_ME_EDGES_ROTATEEDGECCW,
	B_V3D_ED_ME_EDGES_SLIDEEDGE,
	
	B_V3D_ED_ME_EDGES_MENU = 2960,
	
	B_V3D_ED_ME_FACES_MAKEEDGEFACE,
	B_V3D_ED_ME_FACES_FILL,
	B_V3D_ED_ME_FACES_BEAUTIFYFILL,
	B_V3D_ED_ME_FACES_CONVERTQUADSTRIS,
	B_V3D_ED_ME_FACES_CONVERTTRISQUADS,
	B_V3D_ED_ME_FACES_FLIPTRIANGLEEDGES,
	
	B_V3D_ED_ME_FACES_MENU = 3000,
	
	B_V3D_ED_ME_NORMALS_RECALCOUTSIDE,
	B_V3D_ED_ME_NORMALS_RECALCINSIDE,
	B_V3D_ED_ME_NORMALS_FLIP,
	
	B_V3D_ED_ME_NORMALS_MENU = 3020,
	
	B_V3D_ED_ME_REPEATREVOLVE_SPIN,
	B_V3D_ED_ME_REPEATREVOLVE_SPINDUPLICATE,
	B_V3D_ED_ME_REPEATREVOLVE_SCREW,
	B_V3D_ED_ME_REPEATREVOLVE_EXTRUDEREPEAT,
	
	B_V3D_ED_ME_REPEATREVOLVE_MENU = 3040,
	
	B_V3D_ED_ME_SHOWHIDE_SHOWHIDDEN,
	B_V3D_ED_ME_SHOWHIDE_HIDESELECTED,
	B_V3D_ED_ME_SHOWHIDE_HIDEDESELECTED,
	
	B_V3D_ED_ME_SHOWHIDE_MENU = 3060,
	
	
	B_V3D_ED_ME_SCRIPTS = 3200,
	
	B_V3D_ED_ME_SCRIPTS_MENU = 3300,
	
#pragma mark -Edit Mode (Curve)	
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_CU = 4000,
	
	B_V3D_SEL_CU_BORDERSELECT,
	B_V3D_SEL_CU_DESELECTALL,
	B_V3D_SEL_CU_INVERSE,
	B_V3D_SEL_CU_CONTROLPOINTROW,
	
	B_V3D_SEL_CU_MENU = 4040,
	
#pragma mark Curve Menu
	
	/* Select */
	B_V3D_ED_CU = 4100,
	
	B_V3D_ED_CU_RELOADORIGINAL,
	B_V3D_ED_CU_TRANSFORMPROPERTIES,
	B_V3D_ED_CU_INSERTKEY,
	B_V3D_ED_CU_EXTRUDE,
	B_V3D_ED_CU_DUPLICATE,
	B_V3D_ED_CU_MAKESEGMENT,
	B_V3D_ED_CU_TOGGLECYCLIC,
	B_V3D_ED_CU_DELETE,
	B_V3D_ED_CU_PROPORTIONALEDITING,
	
	B_V3D_ED_CU_MENU = 4140,
	
	B_V3D_ED_CU_CONTROLPOINTS_TILT,
	B_V3D_ED_CU_CONTROLPOINTS_CLEARTILT,
	B_V3D_ED_CU_CONTROLPOINTS_SEPARATE,
	B_V3D_ED_CU_CONTROLPOINTS_AUTOMATIC,
	B_V3D_ED_CU_CONTROLPOINTS_TOGGLEFREE,
	B_V3D_ED_CU_CONTROLPOINTS_VECTOR,
	B_V3D_ED_CU_CONTROLPOINTS_MAKEVERTEXPARENT,
	B_V3D_ED_CU_CONTROLPOINTS_ADDHOOK,
	
	B_V3D_ED_CU_CONTROLPOINTS_MENU = 4180,
	
	B_V3D_ED_CU_SEGMENTS_SUBDIVIDE,
	B_V3D_ED_CU_SEGMENTS_SWITCHDIRECTION,
	
	B_V3D_ED_CU_SEGMENTS_MENU = 4220,
	
	B_V3D_ED_CU_SHOWHIDE_SHOWHIDDEN,
	B_V3D_ED_CU_SHOWHIDE_HIDESELECTED,
	B_V3D_ED_CU_SHOWHIDE_HIDEDESELECTED,
	
	B_V3D_ED_CU_SHOWHIDE_MENU = 4260,

#pragma mark -Edit Mode (Metaball)	
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_MB = 5000,
	
	B_V3D_SEL_MB_BORDERSELECT,
	B_V3D_SEL_MB_DESELECTALL,
	
	B_V3D_SEL_MB_MENU = 5040,
	
#pragma mark Meta Menu
	
	/* Select */
	B_V3D_ED_MB = 5100,
	
	B_V3D_ED_MB_UNDOEDITING,
	B_V3D_ED_MB_REDOEDITING,
	B_V3D_ED_MB_TRANSFORMPROPERTIES,
	B_V3D_ED_MB_DUPLICATE,
	B_V3D_ED_MB_DELETE,
	
	B_V3D_ED_MB_MENU = 5140,
	
	B_V3D_ED_MB_SHOWHIDE_SHOWHIDDEN,
	B_V3D_ED_MB_SHOWHIDE_HIDESELECTED,
	B_V3D_ED_MB_SHOWHIDE_HIDEDESELECTED,
	
	B_V3D_ED_MB_SHOWHIDE_MENU = 5180,

#pragma mark -Edit Mode (Text)	
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_TE = 6000,
	
	B_V3D_SEL_TE_MENU = 6040,
	
#pragma mark Text Menu
	
	/* Text */
	B_V3D_ED_TE = 7000,
	
	B_V3D_ED_TE_UNDOEDITING,
	B_V3D_ED_TE_PASTEFROMFILEBUFFER,

	B_V3D_ED_TE_MENU = 7040,
	
	B_V3D_ED_TE_SPECIALCHARS_COPYRIGHT,
	B_V3D_ED_TE_SPECIALCHARS_REGISTEREDTRADEMARK,
	B_V3D_ED_TE_SPECIALCHARS_DEGREESIGN,
	B_V3D_ED_TE_SPECIALCHARS_MULTIPLICATIONSIGN,
	B_V3D_ED_TE_SPECIALCHARS_CIRCLE,
	B_V3D_ED_TE_SPECIALCHARS_SUPERSCRIPT1,
	B_V3D_ED_TE_SPECIALCHARS_SUPERSCRIPT2,
	B_V3D_ED_TE_SPECIALCHARS_SUPERSCRIPT3,
	B_V3D_ED_TE_SPECIALCHARS_DOUBLEGT,
	B_V3D_ED_TE_SPECIALCHARS_DOUBLELT,
	B_V3D_ED_TE_SPECIALCHARS_PROMILLAGE,
	B_V3D_ED_TE_SPECIALCHARS_DUTCHFLORIN,
	B_V3D_ED_TE_SPECIALCHARS_BRITISHPOUND,
	B_V3D_ED_TE_SPECIALCHARS_JAPANESEYEN,
	B_V3D_ED_TE_SPECIALCHARS_GERMANS,
	B_V3D_ED_TE_SPECIALCHARS_SPANISHQUESTION,
	B_V3D_ED_TE_SPECIALCHARS_SPANISHEXCLAMATION,
	
	B_V3D_ED_TE_SPECIALCHARS_MENU = 7080,
	
#pragma mark -Edit Mode (Lattice)	
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_LT = 7100,
	
	B_V3D_SEL_LT_BORDERSELECT,
	B_V3D_SEL_LT_DESELECTALL,
	
	B_V3D_SEL_LT_MENU = 7140,
	
#pragma mark Lattice Menu
	
	/* Lattice */
	B_V3D_ED_LT = 7200,
	
	B_V3D_ED_LT_UNDOEDITING,
	B_V3D_ED_LT_INSERTKEY,
	B_V3D_ED_LT_PROPORTIONALEDITING,
	
	B_V3D_ED_LT_MENU = 7240,
	
#pragma mark -Edit Mode (Armature)	
#pragma mark Select Menu
	
	/* Select */
	B_V3D_SEL_AR = 8000,
	
	B_V3D_SEL_AR_BORDERSELECT,
	B_V3D_SEL_AR_DESELECTALL,
	
	B_V3D_SEL_AR_MENU = 8040,
	
#pragma mark Armature Menu
	
	/* Lattice */
	B_V3D_ED_AR = 8100,
	
	B_V3D_ED_AR_UNDOEDITING,
	B_V3D_ED_AR_TRANSFORMPROPERTIES,
	B_V3D_ED_AR_EXTRUDE,
	B_V3D_ED_AR_DUPLICATE,
	B_V3D_ED_AR_DELETE,
	B_V3D_ED_AR_MAKEBONEPARENT,
	B_V3D_ED_AR_CLEARBONEPARENT,
	
	B_V3D_ED_AR_MENU = 8140,
	
#pragma mark -Pose Mode (Armature)	
#pragma mark Armature Menu
	
	/* Lattice */
	B_V3D_PO_AR = 10000,
	
	B_V3D_PO_AR_TRANSFORMPROPERTIES,
	B_V3D_PO_AR_INSERTKEY,
	B_V3D_PO_AR_COPYCURRENTPOSE,
	B_V3D_PO_AR_PASTEPOSE,
	B_V3D_PO_AR_PASTEFLIPPEDPOSE,
	B_V3D_PO_AR_COPYATTRIBUTES,
	B_V3D_PO_AR_ADDIKTOBONE,
	B_V3D_PO_AR_CLEARIK,
	B_V3D_PO_AR_CLEARCONSTRAINTS,
	B_V3D_PO_AR_FLIPLRNAMES,
	
	
	B_V3D_PO_AR_MENU = 10040,
	
	B_V3D_PO_AR_CLEARTRANSFORM_CLEARLOCATION,
	B_V3D_PO_AR_CLEARTRANSFORM_CLEARROTATION,
	B_V3D_PO_AR_CLEARTRANSFORM_CLEARSCALE,
	B_V3D_PO_AR_CLEARTRANSFORM_CLEARORIGIN,
	
	B_V3D_PO_AR_CLEARTRANSFORM_MENU = 10060,

	B_V3D_PO_AR_SHOWHIDE_SHOWHIDDEN,
	B_V3D_PO_AR_SHOWHIDE_HIDESELECTED,
	B_V3D_PO_AR_SHOWHIDE_HIDEDESELECTED,
	
	B_V3D_PO_AR_SHOWHIDE_MENU = 10080,
	
#pragma mark -Painting Modes
#pragma mark Paint Menu
	
	/* Paint */
	B_V3D_PA_PA = 10200,
	
	B_V3D_PA_PA_UNDOVERTEXPAINT,
	B_V3D_PA_PA_UNDOWEIGHTPAINT,
	B_V3D_PA_PA_CLEARVERTEXCOLORS,
	
	B_V3D_PA_PA_MENU = 10240,
	
	
#pragma mark -Faceselect Mode
#pragma mark Paint Menu
	
	/* Paint */
	B_V3D_FS_FA = 10400,
	
	B_V3D_FS_FA_COPYDRAWMODE,
	B_V3D_FS_FA_UNWRAPUVS,
	B_V3D_FS_FA_ROTATEUVS,
	B_V3D_FS_FA_COPYUVSANDTEXTURES,
	B_V3D_FS_FA_COPYVERTEXCOLORS,
	B_V3D_FS_FA_CLEARVERTEXCOLORS,
	
	B_V3D_FS_FA_MENU = 10440,
	
	B_V3D_FS_FA_SHOWHIDE_SHOWHIDDEN,
	B_V3D_FS_FA_SHOWHIDE_HIDESELECTED,
	B_V3D_FS_FA_SHOWHIDE_HIDEDESELECTED,
	
	B_V3D_FS_FA_SHOWHIDE_MENU = 10480,
	
	B_V3D_FS_FA_PROPERTIES_TEXTURED,
	B_V3D_FS_FA_PROPERTIES_TILED,
	B_V3D_FS_FA_PROPERTIES_LIGHT,
	B_V3D_FS_FA_PROPERTIES_INVISIBLE,
	B_V3D_FS_FA_PROPERTIES_COLLISION,
	B_V3D_FS_FA_PROPERTIES_SHAREDVERTEXCOLORS,
	B_V3D_FS_FA_PROPERTIES_TWOSIDED,
	B_V3D_FS_FA_PROPERTIES_USEOBJECTCOLOR,
	B_V3D_FS_FA_PROPERTIES_HALO,
	B_V3D_FS_FA_PROPERTIES_BILLBOARD,
	B_V3D_FS_FA_PROPERTIES_SHADOW,
	B_V3D_FS_FA_PROPERTIES_TEXT,
	B_V3D_FS_FA_PROPERTIES_OPAQUEBLENDMODE,
	B_V3D_FS_FA_PROPERTIES_ADDITIVEBLENDMODE,
	B_V3D_FS_FA_PROPERTIES_ALPHABLENDMODE,
	
	B_V3D_FS_FA_PROPERTIES_MENU = 10520,
	
	
	
} ;

/* used for the separators in toolbar menus */
#define B_SEPARATOR	50000




struct uiBlock;
struct ScrArea;
struct ID;

/* these used to be in blender/src/headerbuttons.c: */
#define SPACEICONMAX  15 /* See release/datafiles/blenderbuttons */
#define XIC 20
#define YIC 20

int std_libbuttons(struct uiBlock *block, 
       short xco, short yco, int pin, short *pinpoin, 
       int browse, struct ID *id, struct ID *parid, 
       short *menupoin, int users, 
       int lib, int del, int autobut, int keepbut);

char *windowtype_pup(void);

int GetButStringLength(char *str);
void load_space_sound(char *str);
void load_sound_buttons(char *str);
/* end of declarations moved from old headerbuttons.c */

void update_for_newframe_muted(void);
void update_for_newframe_nodraw(int nosound);
void free_matcopybuf(void);
void clear_matcopybuf(void);
void write_videoscape_fs(void);
void write_vrml_fs(void);
void write_dxf_fs(void);
void write_stl_fs(void);
int buttons_do_unpack(void);
struct Scene *copy_scene(struct Scene *sce, int level);

void buttons_active_id(struct ID **id, struct ID **idfrom);

int start_progress_bar(void);
void end_progress_bar(void);
int progress_bar(float done, char *busy_info);

void update_for_newframe(void);

void action_buttons(void);
void buts_buttons(void);
void file_buttons(void);
void image_buttons(void);
void imasel_buttons(void);
void info_buttons(void);
void ipo_buttons(void);
void nla_buttons(void);
void oops_buttons(void);
void seq_buttons(void);
void sound_buttons(void);
void text_buttons(void);
void script_buttons(void);
void time_buttons(struct ScrArea *sa);
void view3d_buttons(void);

void do_global_buttons(unsigned short event);
void do_global_buttons2(short event);

void do_action_buttons(unsigned short event);
void do_buts_buttons(short event);
void do_file_buttons(short event);
void do_image_buttons(unsigned short event);
void do_imasel_buttons(short event);
void do_info_buttons(unsigned short event);
void do_ipo_buttons(short event);
void do_layer_buttons(short event);
void do_nla_buttons(unsigned short event);
void do_oops_buttons(short event);
void do_seq_buttons(short event);
void do_sound_buttons(unsigned short event);
void do_text_buttons(unsigned short event);
void do_time_buttons(struct ScrArea *sa, unsigned short event);
void do_script_buttons(unsigned short event);
void do_view3d_buttons(short event); 

void do_headerbuttons(short event);

/* header_text.c */
void do_text_editmenu_to3dmenu(void *arg, int event);

/* header_info.c */
void do_info_add_meshmenu(void *arg, int event);
void do_info_add_curvemenu(void *arg, int event);
void do_info_add_surfacemenu(void *arg, int event);
void do_info_add_metamenu(void *arg, int event);
void do_info_add_lampmenu(void *arg, int event);
void do_info_addmenu(void *arg, int event);

/* header_view3d.c */
void do_view3d_menus(void *arg, int event);

void do_view3d_select_object_groupedmenu(void *arg, int event);
void do_view3d_select_object_linkedmenu(void *arg, int event);
void do_view3d_select_object_layermenu(void *arg, int event);
void do_view3d_select_object_typemenu(void *arg, int event);
void do_view3d_select_meshmenu(void *arg, int event);
void do_view3d_select_curvemenu(void *arg, int event);
void do_view3d_edit_snapmenu(void *arg, int event);
void do_view3d_edit_mirrormenu(void *arg, int event);
void do_view3d_transform_moveaxismenu(void *arg, int event);
void do_view3d_transform_rotateaxismenu(void *arg, int event);
void do_view3d_transform_scaleaxismenu(void *arg, int event);
void do_view3d_edit_object_mirrormenu(void *arg, int event);
void do_view3d_edit_objectmenu(void *arg, int event);
void do_view3d_edit_meshmenu(void *arg, int event);
void do_view3d_edit_mesh_normalsmenu(void *arg, int event);
void do_view3d_edit_mesh_verticesmenu(void *arg, int event);
void do_view3d_edit_mesh_edgesmenu(void *arg, int event);
void do_view3d_edit_curve_segmentsmenu(void *arg, int event);
void do_view3d_edit_curve_showhidemenu(void *arg, int event); 

#endif /*  BSE_HEADERBUTTONS_H */
