#ifndef _DNA_HEMESH_TYPES_H
#define _DNA_HEMESH_TYPES_H

#include "DNA_ID.h"
#include "DNA_listBase.h"
#include "DNA_object_types.h"

struct Material;
struct BoundBox;
struct HyperMesh;
struct DF_DeformList;

/*we "embedd" morph targets into the mesh
  better this way, much better*/
/*also, we always do array indice-based linked lists 
  for DNA mesh types.*/
  
/*typedef struct HE_KeyVert {
    float co[3];
    int keynext;
} HE_KeyVert;

typedef struct HE_MorphKey {
    char name[128];
    int index;
} HE_MorphKey; NOTE: good project for later*/
    
typedef struct HE_Vert {
    float co[3];
    float no[3];
    unsigned int f, h;
    int vgroup;
    int edge;
    //int key_vert_list;
} HE_Vert;

typedef struct HE_EdgeInfo {
    unsigned int f, h;
	float crease;
	int e1, e2;
	int v1, v2;
	char seam, cpad1;
	short spad2;
} HE_EdgeInfo;

typedef struct HE_Edge {
	int v1;
	int v2;
	int iedge;
	int pair;
	int face;
	int next;
	int prev;
	float no[3];
} HE_Edge;

typedef struct HE_Face {
    int edge;
    float nor[3];
    float dot[3];
    unsigned int f, h;
    char mat_index, cpad1;
    short spad2;
} HE_Face;   

typedef struct HE_Mesh {
    ID id;
    HE_Face *faces;
    int totfaces;
    int ipad1;
    HE_Edge *half_edges;
    HE_EdgeInfo *iedges;
    HE_Vert *verts;
    
    int totedges;
    int totiedges;
    int totverts;
    int ipadf1;
    
    ListBase dl; /*displist*/
    unsigned int f, f1, subdivLevels;
    unsigned int pad;
    struct Material **mat;
    short totcol, spad2;
    int texflag;
    struct BoundBox *bb;
    struct DMesh *dmesh;
    struct DF_DeformList *deforml;
} HE_Mesh;

/*mesh->f*/
#define HEM_SUBSURF	1
#define HEM_TWOSIDE 2

/*face->f*/
#define HEM_SMOOTH	2

/*edge info->f*/
#define HEM_SEAM	2
#define HEM_HARD	4
#define HEM_REMAKE_DISPLIST	8
#define HEM_NODISPLIST	16

#endif /* _DNA_HEMESH_TYPES_H */
